use std::io::Write;
use std::net::TcpStream;
use std::sync::{Arc, RwLock};

use anyhow::Result;

use bank::bank::Bank;

use crate::commands::Command;
use crate::protocol;

pub struct Fail;

impl Command for Fail {
    fn execute(
        &self,
        _: Arc<RwLock<Bank>>,
        error_code: &[u8],
        mut stream: &TcpStream,
    ) -> Result<usize> {
        error!("sending error code {}", error_code[0]);
        let written = stream.write(&protocol::error(error_code[0]))?;
        Ok(written)
    }
}
